#include<stdio.h>
#include<string.h>
#include<signal.h>
#include<ctype.h>

void del_desc(char *str)
{
	int count=0, i;
	for (i=0; str[i]!='\0'; i++)
	{
		if (isspace(str[i]))
			count++;
		if (count==2)
			str[i]='\0';
	}
}

int main(int argc, char** argv)
{
	FILE *data, *dev;
	char line[100], dline[500], pciid[10], dpciid[10];
	int sortorder=0, i=0, file=-1;

	signal(SIGHUP, SIG_IGN);
	signal(SIGINT, SIG_IGN);
	signal(SIGQUIT, SIG_IGN);
	signal(SIGTERM, SIG_IGN);

	if(argc==1)
	{
		puts("Usage: detect [-p|-l] file.pci");
		exit(1);
	}
	while(i++<argc-1)
	{
		if(argv[i][0]=='-')
		{
			if(!strcmp(argv[i], "-p"))
				sortorder=0;
			else if(!strcmp(argv[i], "-l"))
				sortorder=1;
			else
			{
				printf("Incorrect option: \"%s\"\n", argv[i]);
				exit(2);
			}
		}
		else file=i;
	}
	if (file==-1)
	{
		puts("You must select a file");
		exit(2);
	}
	data=fopen(argv[file], "r");
	if(data==NULL)
	{
		printf("File: \"%s\" is incorrect\n", argv[file]);
		exit(3);
	}
	dev=fopen("/proc/bus/pci/devices", "r");
	if(dev==NULL)
	{
		puts("No access to proc filesystem");
		exit(4);
	}

	pciid[8]='\0';
	dpciid[8]='\0';
	if(sortorder)
	{
		while(fgets(line, 100, data)!=NULL)
		{
			del_desc(line);
			while(fgets(dline, 500, dev)!=NULL)
			{
				strncpy(pciid, line, 8);
				strncpy(dpciid, dline+5, 8);
				if(!strcmp(pciid, dpciid))
					puts(line+9);
			}
			rewind(dev);
		}
	}
	else
	{
		while(fgets(dline, 500, dev)!=NULL)
		{
			while(fgets(line, 100, data)!=NULL)
			{
				del_desc(line);
				strncpy(pciid, line, 8);
				strncpy(dpciid, dline+5, 8);
				if(!strcmp(pciid, dpciid))
					puts(line+9);
			}
			rewind(data);
		}
	}
	fclose(data);
	fclose(dev);
	return 0;
}
